#if !defined(__FLLOPQPFETI_H)
#define	__FLLOPQPFETI_H
#include "fllopqp.h"

typedef enum {FETI_LOCAL, FETI_GLOBAL_DECOMPOSED, FETI_GLOBAL_UNDECOMPOSED} QPFetiNumberingType;

   /* if (!enforceByB) MatZeroRowsIS(qp->A, dbcis, diag, qp->x, qp->b) */
FLLOP_EXTERN PetscErrorCode QPFetiAddDirichlet(QP qp, IS dbcis, QPFetiNumberingType numtype, PetscBool enforce_by_B);
   /* l2g_dof_map is mapping from the local dof indexing of decomposed problem to global dof indexing of undecomposed problem */
FLLOP_EXTERN PetscErrorCode QPFetiSetLocalToGlobalMapping(QP qp, IS l2g_dof_map);
FLLOP_EXTERN PetscErrorCode QPFetiSetInterfaceToGlobalMapping(QP qp, IS i2g);
   /* neighbors is a list of neighboring ranks (subdomains) 
      TIP: if (!neighbors) it could perhaps be computed automagically */
FLLOP_EXTERN PetscErrorCode QPFetiSetNeighborRanks(QP qp, IS neighbors);
FLLOP_EXTERN PetscErrorCode QPFetiSetUp(QP qp);
FLLOP_EXTERN PetscErrorCode QPFetiAssembleGluingFromNeighbors(MPI_Comm comm, IS l2g, IS neighbors, PetscInt nlocaldofs, Mat *Bg_new);
FLLOP_EXTERN PetscErrorCode QPFetiAssembleGluing(MPI_Comm comm, IS l2g, IS i2g, PetscBool full_red, Mat *Bg_new);

#endif
